## shasta 0.14.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(shasta)

# This is the top level cmake file for a Shasta build. 

# Before starting a build,
# run shasta/scripts/InstallPrerequisites-Ubuntu.sh

# Use "cmake -D" to modify the options defined below 
# in each "option" line. For example, to turn off
# building the dynamic executable use
# cmake -DBUILD_DYNAMIC_EXECUTABLE=OFF



# Figure out if we are on Intel (as opposed to ARM).
set(X86_64 OFF)
if(${CMAKE_SYSTEM_PROCESSOR} MATCHES "x86_64")
    set(X86_64 ON)
endif()



# Summarize the environment.
message(STATUS "Processor architecture is " ${CMAKE_HOST_SYSTEM_PROCESSOR})
message(STATUS "CMAKE_SYSTEM_NAME is " ${CMAKE_SYSTEM_NAME})



# Decide what we want to build.
option(BUILD_STATIC_LIBRARY "Build the static library." ON)
option(BUILD_STATIC_EXECUTABLE "Build the static executable." ON)
option(BUILD_DYNAMIC_LIBRARY "Build the shared library." ON)
option(BUILD_DYNAMIC_EXECUTABLE "Build the dynamic executable." OFF)



# To build the static executable, we also need the static library.
if(BUILD_STATIC_EXECUTABLE AND NOT BUILD_STATIC_LIBRARY)
    set(BUILD_STATIC_LIBRARY ON)
    message(STATUS "Turned on BUILD_STATIC_LIBRARY because it is needed for BUILD_STATIC_EXECUTABLE.")
endif(BUILD_STATIC_EXECUTABLE AND NOT BUILD_STATIC_LIBRARY)



# To build the dynamic executable, we also need the dynamic library.
if(BUILD_DYNAMIC_EXECUTABLE AND NOT BUILD_DYNAMIC_LIBRARY)
    set(BUILD_DYNAMIC_LIBRARY ON)
    message(STATUS "Turned on BUILD_DYNAMIC_LIBRARY because it is needed for BUILD_DYNAMIC_EXECUTABLE.")
endif(BUILD_DYNAMIC_EXECUTABLE AND NOT BUILD_DYNAMIC_LIBRARY)



# Write out what we will actually build.
message(STATUS "BUILD_STATIC_LIBRARY is " ${BUILD_STATIC_LIBRARY})
message(STATUS "BUILD_STATIC_EXECUTABLE is " ${BUILD_STATIC_EXECUTABLE})
message(STATUS "BUILD_DYNAMIC_LIBRARY is " ${BUILD_DYNAMIC_LIBRARY})
message(STATUS "BUILD_DYNAMIC_EXECUTABLE is " ${BUILD_DYNAMIC_EXECUTABLE})



# Option to build with -march=native.
option(BUILD_NATIVE "Build with -march=native." OFF)
message(STATUS "BUILD_NATIVE is " ${BUILD_NATIVE})



# Option to request a debug build.
option(BUILD_DEBUG "Make a debuggable build." OFF)
message(STATUS "BUILD_DEBUG is " ${BUILD_DEBUG})



# The BUILD_ID can be specified to identify the build
# This is normally used only when building a new GitHub release,
# in which case we use the following option when running Cmake:
# -DBUILD_ID="Shasta Release X.Y.Z"
# BUILD_ID should not contain a comma, otherwise the C preprocessor does not handle it correctly.
if(NOT DEFINED BUILD_ID)
    set(BUILD_ID "Shasta development build. This is not a released version.")
endif(NOT DEFINED BUILD_ID)
message(STATUS "BUILD_ID is: " ${BUILD_ID})



# Add the subdirectories we need.
if(BUILD_STATIC_LIBRARY)
    add_subdirectory(staticLibrary)
endif(BUILD_STATIC_LIBRARY)

if(BUILD_STATIC_EXECUTABLE)
    add_subdirectory(staticExecutable)
endif(BUILD_STATIC_EXECUTABLE)

if(BUILD_DYNAMIC_LIBRARY)
    add_subdirectory(dynamicLibrary)
endif(BUILD_DYNAMIC_LIBRARY)

if(BUILD_DYNAMIC_EXECUTABLE)
    add_subdirectory(dynamicExecutable)
endif(BUILD_DYNAMIC_EXECUTABLE)



# Install to the shasta-install directory.
set(CMAKE_INSTALL_PREFIX .)

# Install the scripts.
file(GLOB SCRIPTS scripts/*.py scripts/*.sh)
install(PROGRAMS ${SCRIPTS} DESTINATION shasta-install/bin)

# Install the configuration files.
install(DIRECTORY conf DESTINATION shasta-install USE_SOURCE_PERMISSIONS)

# Install the docs directory.
install(DIRECTORY docs DESTINATION shasta-install)

# The targets built in each subdirectory are
# installed by the cmake file of each subdirectory.

=== dynamicExecutable/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(shastaDynamicExecutable)

# C++ dialect.
add_definitions(-std=c++20)

# Compilation warnings.
add_definitions(-Wall -Wconversion -Wno-unused-result -Wno-trigraphs -Wno-psabi -Wunused-parameter)

# Optimization and debug options.
if(BUILD_DEBUG)
    add_definitions(-ggdb3)
    add_definitions(-O0)
    # Address sanitizer does not work well with the Python API,
    # so it is commented out here. But it could be useful
    # to debug the dynamic executable. 
    # add_definitions(-fsanitize=address)
else(BUILD_DEBUG)
    add_definitions(-g0)
    add_definitions(-O3)
    # NDEBUG is required to turn off SeqAn debug code.
    add_definitions(-DNDEBUG)
endif(BUILD_DEBUG)

# 16-byte compare and swap.
# This is recommended for dset64.hpp/dset64-gccAtomic.hpp".
# It's available only on x86 architectures.
if(X86_64)
  add_definitions(-mcx16)
endif()

# Native build.
if(BUILD_NATIVE)
    add_definitions(-march=native)
endif(BUILD_NATIVE)

# Build id.
add_definitions(-DBUILD_ID=${BUILD_ID})

# Definitions needed to eliminate dependency on the boost system library.
add_definitions(-DBOOST_SYSTEM_NO_DEPRECATED)
add_definitions(-DBOOST_ERROR_CODE_HEADER_ONLY)

# This is needed to avoid some Boost warnings about deprecated messages.
# We canot fix this in Shasta as it is a Boost problem.
# It can be removed if Boost is fixed.
add_definitions(-DBOOST_ALLOW_DEPRECATED_HEADERS)

add_definitions(-DSHASTA_PYTHON_API)

# Source files
file(GLOB SOURCES ../srcMain/*.cpp)

# Include directory.
include_directories(../src)

# Define our executable.
add_executable(shastaDynamicExecutable ${SOURCES})
set_target_properties(shastaDynamicExecutable PROPERTIES OUTPUT_NAME "shastaDynamic")

# This is needed to make sure the executable looks for the shared
# library in the same directory.
set_target_properties(shastaDynamicExecutable PROPERTIES INSTALL_RPATH "\$ORIGIN")

# Libraries to link with.
if(X86_64)
    target_link_libraries(
        shastaDynamicExecutable
        shastaDynamicLibrary
        atomic boost_system boost_program_options boost_chrono boost_serialization spoa png z 
        lapack blas quadmath pthread)
else(X86_64)
    target_link_libraries(
        shastaDynamicExecutable
        shastaDynamicLibrary
        atomic boost_system boost_program_options boost_chrono boost_serialization spoa png z 
        lapack blas pthread)
endif(X86_64)

if(BUILD_DEBUG) 
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fsanitize=address")
endif(BUILD_DEBUG)

# Install the dynamic executable into the bin directory.
install(TARGETS shastaDynamicExecutable DESTINATION shasta-install/bin)

=== dynamicLibrary/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(shastaDynamicLibrary)

# C++ dialect.
add_definitions(-std=c++20)

# Compilation warnings.
add_definitions(-Wall -Wconversion -Wno-unused-result -Wno-trigraphs -Wno-psabi -Wunused-parameter)

# Optimization and debug options.
if(BUILD_DEBUG)
    add_definitions(-ggdb3)
    add_definitions(-O0)
    # Address sanitizer does not work well with the Python API,
    # so it is commented out here. But it could be useful
    # to debug the dynamic executable. 
    # add_definitions(-fsanitize=address)
else(BUILD_DEBUG)
    add_definitions(-g0)
    add_definitions(-O3)
    # NDEBUG is required to turn off SeqAn debug code.
    add_definitions(-DNDEBUG)
endif(BUILD_DEBUG)

# 16-byte compare and swap.
# This is recommended for dset64.hpp/dset64-gccAtomic.hpp".
# It's available only on x86 architectures.
if(X86_64)
  add_definitions(-mcx16)
endif(X86_64)

# Native build.
if(BUILD_NATIVE)
    add_definitions(-march=native)
endif(BUILD_NATIVE)

# Build id.
add_definitions(-DBUILD_ID=${BUILD_ID})

# Definitions needed to eliminate dependency on the boost system library.
add_definitions(-DBOOST_SYSTEM_NO_DEPRECATED)
add_definitions(-DBOOST_ERROR_CODE_HEADER_ONLY)

# This is needed to avoid some Boost warnings about deprecated messages.
# We canot fix this in Shasta as it is a Boost problem.
# It can be removed if Boost is fixed.
add_definitions(-DBOOST_ALLOW_DEPRECATED_HEADERS)

add_definitions(-DSHASTA_PYTHON_API)

# Sources files.
file(GLOB SOURCES ../src/*.cpp)

# Include directory.
include_directories(../src)

# Define our library.
add_library(shastaDynamicLibrary SHARED ${SOURCES})

# Make sure the library is named shasta.so.
set_target_properties(shastaDynamicLibrary PROPERTIES OUTPUT_NAME "shasta")
set_target_properties(shastaDynamicLibrary PROPERTIES PREFIX "")
set_target_properties(shastaDynamicLibrary PROPERTIES DEFINE_SYMBOL "")



# Python 3 and pybind11.
execute_process(COMMAND /usr/bin/python3-config --embed --libs OUTPUT_VARIABLE SHASTA_PYTHON_LIBRARIES)
execute_process(COMMAND python3 -m pybind11 --includes OUTPUT_VARIABLE SHASTA_PYTHON_INCLUDES)
add_definitions(${SHASTA_PYTHON_INCLUDES})
string(STRIP ${SHASTA_PYTHON_LIBRARIES} SHASTA_PYTHON_LIBRARIES)
SET(CMAKE_LINKER_FLAGS  "${CMAKE_LINKER_FLAGS} ${SHASTA_PYTHON_LIBRARIES}")



# Libraries to link with.
target_link_libraries(
    shastaDynamicLibrary 
     atomic png boost_program_options boost_serialization pthread z spoa lapack blas ${SHASTA_PYTHON_LIBRARIES})

# Install the shared library into the bin directory.
install(TARGETS shastaDynamicLibrary DESTINATION shasta-install/bin)

=== staticExecutable/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(shastaStaticExecutable)

# C++ dialect.
add_definitions(-std=c++20)

# Compilation warnings.
add_definitions(-Wall -Wconversion -Wno-unused-result -Wno-trigraphs -Wno-psabi -Wunused-parameter)

# Optimization and debug options.
if(BUILD_DEBUG)
    add_definitions(-ggdb3)
    add_definitions(-O0)
else(BUILD_DEBUG)
    add_definitions(-g0)
    add_definitions(-O3)
    # NDEBUG is required to turn off SeqAn debug code.
    add_definitions(-DNDEBUG)
endif(BUILD_DEBUG)

# 16-byte compare and swap.
# This is recommended for dset64.hpp/dset64-gccAtomic.hpp".
# It's available only on x86 architectures.
if(X86_64)
    add_definitions(-mcx16)
endif(X86_64)

# Native build.
if(BUILD_NATIVE)
    add_definitions(-march=native)
endif(BUILD_NATIVE)

# Build id.
add_definitions(-DBUILD_ID=${BUILD_ID})

# Definitions needed to eliminate dependency on the boost system library.
add_definitions(-DBOOST_SYSTEM_NO_DEPRECATED)
add_definitions(-DBOOST_ERROR_CODE_HEADER_ONLY)

# This is needed to avoid some Boost warnings about deprecated messages.
# We canot fix this in Shasta as it is a Boost problem.
# It can be removed if Boost is fixed.
add_definitions(-DBOOST_ALLOW_DEPRECATED_HEADERS)

# Source files
file(GLOB SOURCES ../srcMain/*.cpp)

# Include directory.
include_directories(../src)

# Define our executable.
add_executable(shastaStaticExecutable ${SOURCES})
set_target_properties(shastaStaticExecutable PROPERTIES OUTPUT_NAME "shasta")

# Request a static executable.
set_target_properties(shastaStaticExecutable PROPERTIES LINK_FLAGS "-static" )

# Libraries to link with.
# For arcane reasons, statically linking with the pthread
# library on Linux requires "--whole-archive".
if(X86_64)
    target_link_libraries(
        shastaStaticExecutable
        shastaStaticLibrary
        atomic boost_system boost_program_options boost_chrono boost_serialization  spoa png z
        lapack blas gfortran quadmath
        -Wl,--whole-archive -lpthread -Wl,--no-whole-archive)
else(X86_64)
    target_link_libraries(
        shastaStaticExecutable
        shastaStaticLibrary
        atomic boost_system boost_program_options boost_chrono boost_serialization spoa png z
        lapack blas gfortran
        -Wl,--whole-archive -lpthread -Wl,--no-whole-archive)
endif(X86_64) 
  
# The static executable goes to the bin directory.
install(TARGETS shastaStaticExecutable DESTINATION shasta-install/bin)

=== staticLibrary/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(shastaStaticLibrary)

# C++ dialect.
add_definitions(-std=c++20)

# Compilation warnings.
add_definitions(-Wall -Wconversion -Wno-unused-result -Wno-trigraphs -Wno-psabi -Wunused-parameter)

# Optimization and debug options.
if(BUILD_DEBUG)
    add_definitions(-ggdb3)
    add_definitions(-O0)
else(BUILD_DEBUG)
    add_definitions(-g0)
    add_definitions(-O3)
    # NDEBUG is required to turn off SeqAn debug code.
    add_definitions(-DNDEBUG)
endif(BUILD_DEBUG)

# 16-byte compare and swap.
# This is recommended for dset64.hpp/dset64-gccAtomic.hpp".
# It's available only on x86 architectures.
if(X86_64)
  add_definitions(-mcx16)
endif(X86_64)

# Native build.
if(BUILD_NATIVE)
    add_definitions(-march=native)
endif(BUILD_NATIVE)

# Build id.
add_definitions(-DBUILD_ID=${BUILD_ID})

# Definitions needed to eliminate dependency on the boost system library.
add_definitions(-DBOOST_SYSTEM_NO_DEPRECATED)
add_definitions(-DBOOST_ERROR_CODE_HEADER_ONLY)

# This is needed to avoid some Boost warnings about deprecated messages.
# We canot fix this in Shasta as it is a Boost problem.
# It can be removed if Boost is fixed.
add_definitions(-DBOOST_ALLOW_DEPRECATED_HEADERS)

# Sources files.
file(GLOB SOURCES ../src/*.cpp)

# Include directory.
include_directories(../src)

# Define our library.
add_library(shastaStaticLibrary STATIC ${SOURCES})

# Make sure the library is named shasta.a.
set_target_properties(shastaStaticLibrary PROPERTIES OUTPUT_NAME "shasta")
set_target_properties(shastaStaticLibrary PROPERTIES PREFIX "")
set_target_properties(shastaStaticLibrary PROPERTIES DEFINE_SYMBOL "")

# Install the static library into the bin directory.
install(TARGETS shastaStaticLibrary DESTINATION shasta-install/bin)

=== debian/changelog ===
shasta (0.14.0-1) unstable; urgency=medium

  [ Michael R. Crusoe ]
  * Team upload.
  * New upstream version
  * Support the "nodoc" and "nocheck" build profiles, increasing
    cross-buildability.
  * Added patch to keep debug information.
  * d/rules: save time by not building the static library.
  * d/upstream/metadata: new upstream location
  * d/control: move docs build-deps to the architecture independent
    list.
  * Strip unusual field spacing from debian/control.
  * d/control: Needs newer SeqAn2 2.5.0+. Closes: #1125658
  * Standards-Version: 4.7.3 (routine-update)

  [ Andreas Tille ]
  * d/watch: version=5
  * Standards-Version: 4.7.2 (routine-update)
  * Compatibility for boost 1.88
    Closes: #1110602
  * Salsa CI: release: experimental

 -- Michael R. Crusoe <crusoe@debian.org>  Sat, 24 Jan 2026 17:54:34 +0100

=== debian/control ===
Source: shasta
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Shayan Doust <hello@shayandoust.me>,
           Étienne Mollier <emollier@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-exec,
               dh-sequence-python3,
               cmake,
               patchelf,
               chrpath,
               libboost-dev,
               libboost-system-dev,
               libboost-program-options-dev,
               libboost-chrono-dev,
               libboost-serialization-dev,
               libpng-dev,
               python3-dev:native,
               libpython3-dev,
               libseqan2-dev (>= 2.5),
               libspoa-dev,
               python3-pybind11,
               libcpu-features-dev [any-amd64],
               libcereal-dev,
               libblas-dev,
               liblapack-dev
Build-Depends-Indep: python3-sphinx <!nodoc>,
                      dh-sequence-sphinxdoc <!nodoc>
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/med-team/shasta
Vcs-Git: https://salsa.debian.org/med-team/shasta.git
Homepage: https://paoloshasta.github.io/shasta/
Rules-Requires-Root: no

Package: shasta
Architecture: any-amd64 arm64
# even if one comments out the sections that forbid compilation on other archs
# one gets this error message:
# undefined reference to `__sync_bool_compare_and_swap_16'
# see src/dset64.hpp for more details
Depends: ${misc:Depends},
         ${shlibs:Depends},
         python3-shasta (= ${binary:Version}),
Description: nanopore whole genome assembly (binaries and scripts)
 De novo assembly from Oxford Nanopore reads. The goal of the Shasta long
 read assembler is to rapidly produce accurate assembled sequence using
 as input DNA reads generated by Oxford Nanopore flow cells.
 .
 Computational methods used by the Shasta assembler include:
 .
  * Using a run-length representation of the read sequence. This makes
    the assembly process more resilient to errors in homopolymer
    repeat counts, which are the most common type of errors in Oxford
    Nanopore reads.
 .
  * Using in some phases of the computation a representation of the read
    sequence based on markers, a fixed subset of short k-mers (k ≈ 10).
 .
 Shasta assembly quality is comparable or better than assembly quality
 achieved by other long read assemblers.
 .
 This package contains the executable binaries (tools) and
 accommodating scripts.

Package: python3-shasta
Architecture: any-amd64 arm64
Section: python
Depends: ${python3:Depends},
         ${shlibs:Depends},
         ${misc:Depends},
         ncbi-blast+
Description: nanopore whole genome assembly (dynamic library)
 De novo assembly from Oxford Nanopore reads. The goal of the Shasta long
 read assembler is to rapidly produce accurate assembled sequence using
 as input DNA reads generated by Oxford Nanopore flow cells.
 .
 Computational methods used by the Shasta assembler include:
 .
  * Using a run-length representation of the read sequence. This makes
    the assembly process more resilient to errors in homopolymer
    repeat counts, which are the most common type of errors in Oxford
    Nanopore reads.
 .
  * Using in some phases of the computation a representation of the read
    sequence based on markers, a fixed subset of short k-mers (k ≈ 10).
 .
 Shasta assembly quality is comparable or better than assembly quality
 achieved by other long read assemblers.
 .
 This package contains the dynamic library that can be interfaced and
 imported within Python.

Package: python3-shasta-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Built-Using: ${sphinxdoc:Built-Using}
Build-Profiles: <!nodoc>
Depends: ${sphinxdoc:Depends},
         ${misc:Depends}
Recommends: shasta,
            python3-shasta
Description: nanopore whole genome assembly (documentation)
 De novo assembly from Oxford Nanopore reads. The goal of the Shasta long
 read assembler is to rapidly produce accurate assembled sequence using
 as input DNA reads generated by Oxford Nanopore flow cells.
 .
 Computational methods used by the Shasta assembler include:
 .
  * Using a run-length representation of the read sequence. This makes
    the assembly process more resilient to errors in homopolymer
    repeat counts, which are the most common type of errors in Oxford
    Nanopore reads.
 .
  * Using in some phases of the computation a representation of the read
    sequence based on markers, a fixed subset of short k-mers (k ≈ 10).
 .
 Shasta assembly quality is comparable or better than assembly quality
 achieved by other long read assemblers.
 .
 This package contains the documentation for the shasta and python3-shasta
 packages.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8

include /usr/share/dpkg/default.mk

# for hardening you might like to uncomment this:
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
MULTIARCH_SONAME = shasta.cpython-$(shell py3versions -vd | sed 's/\.//')-$(DEB_HOST_MULTIARCH).so

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_ID=${DEB_VERSION_UPSTREAM} \
				-DBUILD_STATIC_EXECUTABLE=OFF \
				-DBUILD_DYNAMIC_EXECUTABLE=ON \
				-DBUILD_STATIC_LIBRARY=OFF

execute_after_dh_auto_build-indep: export http_proxy=127.0.0.1:9
execute_after_dh_auto_build-indep: export https_proxy=127.0.0.1:9
execute_after_dh_auto_build-indep:
ifeq (,$(findstring nodoc, $(DEB_BUILD_OPTIONS)))
	# Move shared library into sphinx documentation folder for doc generation
	find . -name "shasta.so" -exec cp {} docs/PythonApi/ \;
	PYTHONPATH=docs/PythonApi/ python3 -m sphinx -N -bhtml docs/PythonApi/ build/html # HTML generator
endif

override_dh_install-arch:
	dh_install -a
	# Rename shastaDynamic to shasta for ease
	mv debian/shasta/usr/bin/shastaDynamic debian/shasta/usr/bin/shasta

execute_after_dh_python3-arch:
	patchelf \
		--set-soname $(MULTIARCH_SONAME) \
		$(CURDIR)/debian/python3-shasta/usr/lib/python3/dist-packages/$(MULTIARCH_SONAME)

override_dh_missing:
	# No need to install docker files
	find debian/tmp -type d -name docker | xargs rm -rf
	# static library should not be installed
	find debian/tmp -name shasta.a -delete
	# dynamic library was installed manually before - so remove it from debian/tmp
	find debian/tmp -name shasta.so -delete
	# 11MB of generated docs should go into a separate package if this is considered sensible
	# FIXME: for the moment do not install these
	find debian/tmp -name docs | xargs rm -rf
	# Remove rest of files which have already been installed
	rm -rf debian/tmp/${CURDIR}
	dh_missing --list-missing

execute_after_dh_shlibdeps:
	# The library is in a more unusual place (nested within /usr/lib), so
	# modify the ELF
	chrpath -r /usr/lib/python3/dist-packages \
		debian/shasta/usr/bin/shasta
	patchelf \
		--replace-needed shasta.so $(MULTIARCH_SONAME) \
		debian/shasta/usr/bin/shasta

override_dh_dwz-arch:
	dh_dwz -a --exclude=shasta.cpython
# Fixes the following error
# dwz: Allocatable section in debian/python3-shasta/usr/lib/python3/dist-packages/shasta.cpython-312-x86_64-linux-gnu.so after non-allocatable ones

=== debian/watch ===
Version: 5

Template: Github
Owner: paoloshasta
Project: shasta
